// Burstmode and Turbomode test / December 2023 / paulvha
#include "rtos/ThisThread.h"
#include "rtos/Kernel.h"
#include <chrono>
#include "BurstMode.h"

int  led = LED_BUILTIN;         // led to provide some progress info
using namespace std::chrono;
static rtos::Thread* LoopThread = NULL;

static void TLoop()
{
  rtos::Kernel::Clock::time_point now_ms = rtos::Kernel::Clock::now();
  bool h = false;
  unsigned long startTime, endTime;
  uint8_t cnt = 0;

  while (1) {
    
    // switch between normal and burst
    cnt++;
    if (cnt == 4) {
      Serial.print("\nEnable normal mode, ");
      disableBurstMode();
      Serial.print("BurstStatus now: ");
      Serial.println(CLKGEN->FREQCTRL_b.BURSTSTATUS);
    }
    else if (cnt == 8) {
      Serial.print("\nEnable burst mode, ");
      enableBurstMode();
      Serial.print("BurstStatus now: ");
      Serial.println(CLKGEN->FREQCTRL_b.BURSTSTATUS);
      cnt = 0;
    }

    // show some action
    if (h) {
      digitalWrite(led, HIGH);
      Serial.println("On");
    }
    else {
      digitalWrite(led, LOW);
      Serial.println("Off");
    }
    
    h = ! h;

    // set Thread sleep
    now_ms = rtos::Kernel::Clock::now();
    now_ms += 5s;

    startTime = millis();
    rtos::ThisThread::sleep_until(now_ms);
    endTime = millis();

    Serial.printf("elapsed milliseconds %d\n", endTime - startTime);
  }
}

void setup() {
  Serial.begin(115200);
  while (!Serial);
  Serial.println("test Sleep_until - dec 2023 / pauvha");
  
  Serial.print("After rest normal mode , BurstStatus before: ");
  Serial.println(CLKGEN->FREQCTRL_b.BURSTSTATUS);
  Serial.print("Enable burst mode, ");
  enableBurstMode();
  Serial.print("BurstStatus now: ");
  Serial.println(CLKGEN->FREQCTRL_b.BURSTSTATUS);

  pinMode(led, OUTPUT);        // set the LED pin mode
  digitalWrite(led, LOW);

  LoopThread = new rtos::Thread();
  LoopThread->start(TLoop);
}

void loop() {
  // put your main code here, to run repeatedly:

}
